   This file documents the use of MIT Scheme.

   Copyright (C) 1991-2002 Massachusetts Institute of Technology

   Permission is granted to copy, distribute and/or modify this document
under the terms of the GNU Free Documentation License, Version 1.1 or
any later version published by the Free Software Foundation; with no
Invariant Sections, with no Front-Cover Texts, and with no Back-Cover
Texts.  A copy of the license is included in the section entitled "GNU
Free Documentation License".

Leaving Edwin
=============

   Once Edwin has been entered, it can be exited in the following ways:

`C-x z'
     Stop Edwin and return to Scheme (`suspend-edwin').  The call to the
     procedure `edit' that entered Edwin returns normally.  A subsequent
     call to `edit' will resume Edwin where it was stopped.

`C-x c'
     Offer to save any modified buffers, then kill Edwin, returning to
     Scheme (`save-buffers-kill-edwin').  This is like the
     `suspend-edwin' command, except that a subsequent call to `edit'
     will reinitialize the editor.

`C-x C-z'
     Stop Edwin and suspend Scheme, returning control to the operating
     system's command interpreter (`suspend-scheme').  When Scheme is
     resumed (using the command interpreter's job-control commands),
     Edwin is automatically restarted where it was stopped.  This
     command is identical to the `C-x C-z' command of GNU Emacs.

`C-x C-c'
     Offer to save any modified buffers, then kill both Edwin and Scheme
     (`save-buffers-kill-scheme').  Control is returned to the operating
     system's command interpreter, and the Scheme process is terminated.
     This command is identical to the `C-x C-c' command of GNU Emacs.

Scheme Mode
===========

   As you might expect, Edwin has special support for editing and
evaluating Scheme code.  This section describes "Scheme Mode", the
appropriate mode for editing MIT Scheme programs.

   Scheme mode is normally entered automatically by visiting a file
whose file name ends in `.scm'.  You can also mark a file as Scheme code
by placing the string `-*-Scheme-*-' on the first line of the file.
Finally, you can put any buffer in Scheme mode by executing the command
`M-x scheme-mode'.

   Scheme mode is similar to the Emacs modes that edit Lisp code.  So,
for example, `C-i' indents the current line, and `C-M-q' indents the
expression to the right of point.  The close parenthesis will
temporarily flash the matching open parenthesis.  Most Scheme constructs
requiring special indentation are recognized by Scheme mode, for
example, `begin', `do', and `let'.

   Scheme mode also provides support that is specific to Scheme
programs, much as Emacs-Lisp mode does in Emacs.  Completion of global
variable names is provided: type the first few characters of a
variable, then type `C-M-i', and Edwin will attempt to complete the
variable name using the current set of bound variables.  If `C-M-i' is
given a prefix argument, it will complete the name using the current
set of interned symbols (which includes the bound variables as a
subset).

   The `M-A' command (note the _uppercase_ `A') will show the
parameters of a procedure when point is inside a procedure call.  For
example, type the string `(quotient', then press `M-A', and the command
will echo `(n d)' in the echo area.  With a prefix argument, `M-A' will
insert the parameter names in the buffer at point, so in this example,
the buffer would contain `(quotient n d' after running `C-u M-A'.

Evaluation
==========

   Scheme mode also provides commands for evaluating Scheme expressions.
The simplest evaluation command is `C-x C-e', which evaluates the
expression to the left of point.  (This key is bound in all buffers,
even if they don't contain Scheme code.)  The command `M-z' evaluates
the definition that point is in (a definition is an expression starting
with a left parenthesis in the leftmost column).  The command `M-:'
prompts for an expression in the minibuffer, evaluates it, and prints
the value in the echo area.

   Other commands that evaluate larger amounts of code are `C-M-z',
which evaluates all of the expressions in the region, and `M-o', which
evaluates the entire buffer.  Both of these commands are potentially
dangerous in that they will evaluate anything that appears to be an
expression, even if it isn't intended to be.

   Normally, these commands evaluate expressions by sending them to a
REPL buffer, which performs the evaluations in a separate thread.  This
has two advantages: it allows you to continue editing while the
evaluation is happening, and it keeps a record of each evaluation and
its printed output.  If you wish to stop a running evaluation and to
erase any pending expressions, use the `C-c C-c' command from any
Scheme buffer.  (Note that by default, Edwin starts up with one REPL
buffer, called `*scheme*'.)

   If you would prefer to have Scheme mode evaluation commands evaluate
directly, rather than sending expressions to the REPL buffer, set the
Edwin variable `evaluate-in-inferior-repl' to `#f'.  In this case, you
will not be able to use Edwin while evaluation is occurring; any output
from the evaluation will be shown in a pop-up buffer when the
evaluation finishes; and you abort the evaluation using `C-g'.

REPL Mode
=========

   Edwin provides a special mechanism for interacting with Scheme
read-eval-print loops: REPL buffers.  A REPL buffer is associated with
a Scheme REPL running in a separate thread of execution; because of
this, expressions may be evaluated in this buffer while you
simultaneously do other things with the editor.  A REPL buffer captures
all printed output from an evaluated expression, as well as supporting
interactive programs such as `debug'.  For these and other reasons,
REPL buffers are the preferred means for interacting with the Scheme
interpreter.

   When Edwin starts, it has one buffer: a REPL buffer called
`*scheme*'.  The command `M-x repl' selects this buffer, if it exists;
otherwise it creates a new REPL buffer.  If you want two REPL buffers,
just rename the `*scheme*' buffer to something else and run `M-x repl'
again.

   REPL buffers support all the same evaluation commands that Scheme
mode does; in fact, REPL buffers use a special mode called REPL mode
that inherits from Scheme mode.  Thus, any key bindings defined in
Scheme mode are also defined in REPL mode.  One exception to this is
the `M-o' command, which is deliberately undefined in REPL mode;
otherwise it would be too easy to re-evaluate all the previously
evaluated expressions in the REPL buffer.

   In addition to evaluation commands, REPL mode provides a handful of
special commands for controlling the REPL itself.  The commands `C-c
C-x' and `C-c C-u' abort the current evaluation, returning to the
current or previous REPL levels, respectively.  The command `C-c C-b'
interrupts the current evaluation, entering a breakpoint.

   Each REPL buffer maintains a history of the expressions that were
typed into it.  Several commands allow you to access the contents of
this history.  The command `M-p' moves backwards through the history,
inserting previously evaluated expressions at point.  Likewise, `M-n'
moves forward through the history.  The commands `C-c C-r' and `C-c
C-s' search backward and forward through the history for a particular
string.  The command `C-c C-o' deletes any output from the previous
evaluation; use this command with care since it cannot be undone.  The
command `C-c C-l' finds the most recent expression in the buffer and
moves point there.

   When an expression that you evaluate signals an error, the REPL
buffer notices this and offers to run the debugger for you.  Answer this
question with a `y' or `n' response.  You can start the debugger
whenever the REPL buffer is listening by executing the `C-c C-d'
command.  In either case, this starts the Edwin debugger, which pops up
a new window containing the debugger.  Your REPL buffer remains in the
error state, allowing you to examine it further if you wish.

The Edwin Debugger
==================

   The Edwin debugger is similar to the command-line debugger, except
that it takes advantage of multiple windows and Edwin's command
structure to provide a more intuitive interface.  The debugger operates
as a browser, much like Dired, presenting you with an overview of the
subproblem structure, and allowing you to examine parts of that
structure in more detail by selecting the parts.  When started, the
debugger creates a buffer `*debug*' showing the subproblem structure,
and selects the first line.

   Each line beginning with `S' represents either a subproblem or stack
frame.  A subproblem line may be followed by one or more indented lines
(beginning with the letter `R') which represent reductions associated
with that subproblem.  The subproblems are indexed with the natural
numbers.  To obtain a more complete description of a subproblem or
reduction, click the mouse on the desired line or move the cursor to
the line using the arrow keys (or `C-n' and `C-p').  The description
buffer will display the additional information.

   The description buffer contains three major regions.  The first
region contains a pretty-printed version of the current expression.  The
current subproblem within the expression is highlighted.  The second
region contains a representation of the frames of the environment of the
current expression.  The bindings of each frame are listed below the
frame header.  If there are no bindings in the frame, none will be
listed.  The frame of the current expression is preceded with `==>'.

   The bottom of the description buffer contains a third region for
evaluating expressions in the environment of the selected subproblem or
reduction.  This is the only portion of the buffer where editing is
possible.  This region can be used to find the values of variables in
different environments, or even to modify variable values or data
structures (note that variables in compiled code cannot usually be
modified).

   Typing `e' creates a new buffer in which you may browse through the
current environment.  In this new buffer, you can use the mouse, the
arrows, or `C-n' and `C-p' to select lines and view different
environments.  The environments listed are the same as those in the
description buffer.  If the selected environment structure is too large
to display (i.e. if the number of bindings in the environment exceeds
the value of the editor variable `environment-package-limit') a message
to that effect is displayed.  To display the environment in this case,
use `M-x set-variable' to set `environment-package-limit' to `#f'.  At
the bottom of the new buffer is a region for evaluating expressions,
similar to that of the description buffer.

   The appearance of environment displays is controlled by the editor
variables `debugger-show-inner-frame-topmost?' and
`debugger-compact-display?'  which affect the ordering of environment
frames and the line spacing respectively.

   Type `q' to quit the debugger, killing its primary buffer, any
others that it has created, and the window that was popped up to show
the debugger.

   *Note*: The description buffers created by the debugger are given
names beginning with spaces so that they do not appear in the buffer
list; these buffers are automatically deleted when you quit the
debugger.  If you wish to keep one of these buffers, simply rename it
using `M-x rename-buffer': once it has been renamed, it will not be
automatically deleted.

Last Resorts
============

   When Scheme exits abnormally it tries to save any unsaved Edwin
buffers.  The buffers are saved in an auto-save file in case the
original is more valuable than the unsaved version.  You can use the
editor command `M-x recover-file' to recover the auto-saved version.
The name used to specify an auto-save file is operating-system
dependent: under unix, and on PC file systems with long file names,
`foo.scm' will be saved as `#foo.scm#'; on PC file systems with short
file names, it will be saved as `foo.sav'.

   The following Scheme procedures are useful for recovering from bugs
in Edwin's implementation.  All of them are designed for use when Edwin
is _not_ running -- they should not be used when Edwin is running.
These procedures are designed to help Edwin's implementors deal with
bugs during the implementation of the editor; they are not intended for
casual use, but as a means of recovering from bugs that would otherwise
require reloading the editor's world image from the disk.

 - procedure+: save-editor-files
     Examines Edwin, offering to save any unsaved buffers.  This is
     useful if some bug caused Edwin to die while there were unsaved
     buffers, and you want to save the information without restarting
     the editor.

 - procedure+: reset-editor
     Resets Edwin, causing it to be reinitialized the next time that
     `edit' is called.  If you encounter a fatal bug in Edwin, a good
     way to recover is to first call `save-editor-files', and then to
     call `reset-editor'.  That should completely reset the editor to
     its initial state.

 - procedure+: reset-editor-windows
     Resets Edwin's display structures, without affecting any of the
     buffers or their contents.  This is useful if a bug in the display
     code causes Edwin's internal display data structures to get into
     an inconsistent state that prevents Edwin from running.

Release Notes
*************

   The previous full release of MIT Scheme was version 7.5.17.  This
section describes changes that have occurred since that time.  For more
detailed information, see the `ChangeLog' files in the source code.

   Note that MIT Scheme still conforms to the `Revised^4 Report on the
Algorithmic Language Scheme', but not to the `Revised^5 Report on The
Algorithmic Language Scheme'.

Recent Changes
==============

   These are the changes since release 7.6.0:

   * Release 7.7.1 fixes several bugs in IMAIL; fixes a bug that
     prevented the use of server sockets on Windows systems; and fixes
     a bug that caused the debugger to generate errors in common
     circumstances.

   * Release 7.7.0 provides "hygienic" macro support, as defined in
     `R^4RS' and `R^5RS'.  This is a complete rewrite of the syntax
     engine, so any program that uses macros should be rewritten to use
     the new engine.  A subset of the old macro-definition syntax is
     still supported, but this will eventually be removed.  Note that
     the new syntax engine has no effect on the compiled-code format;
     most binaries compiled by release 7.6.x should continue to work.

     There are several user-visible consequences to this change:

        * These syntactic keywords have been eliminated: `define-macro',
          `in-package', `macro', `make-environment', `scode-quote',
          `unassigned?', and `using-syntax'.

        * The syntactic keyword `the-environment' has been restricted
          to use in top-level environments.  It is no longer allowed in
          the body of any binding form (e.g. `lambda', `let').

        * Syntactic keywords are now stored in environments, rather
          than in a separate syntax-table structure.  The environment
          abstraction has been enhanced to support this, as well as to
          make it more general.  The changes are documented in the
          reference manual.

        * The syntax-table abstraction has been eliminated, and most
          procedures and arguments involving syntax tables have been
          removed.  One exception is the `load' procedure, which still
          accepts a syntax-table argument, but ignores it.

     Although the 7.6.1 release had a workaround for problems with
     certain AMD Athlon processors, the workaround was ineffective on
     machines running Windows operating systems (and possibly OS/2
     systems as well).  This version fixes that problem.

     The hash-table abstraction is now always loaded.  It's not
     necessary to call `load-option' prior to use of hash tables.  For
     upwards compatibility, calling `(load-option 'hash-table)' is still
     permitted but does nothing.

   * Release 7.6.1 provides a workaround for a bug on some AMD Athlon
     processors (specifically, models 1, 3, and 4).  This bug causes
     those processors to incorrectly execute certain kinds of
     self-modifying code, including that used by MIT Scheme.

     Release 7.6.1 also fixes a problem that caused the *PARSER and XML
     subsystems not to load correctly on Windows and OS/2 systems.

Older Changes
=============

   These are the changes that occurred between releases 7.6.0 and
7.5.17:

   * The variable-reference machinery has been completely redesigned.
     The new design provides two new features: (1) a procedure
     `link-variables' that can link two variable bindings with
     different names (previously `environment-link-name' could only
     link bindings with the same name); (2) a new procedure
     `unbind-variable' that can remove a variable binding.  Both of
     these operations work only on "top-level" environments; they don't
     work on environments created by invoking compiled procedures.

     *This is an incompatible change to the compiled-code
     representation.  All programs must be recompiled.*

   * The "packaging" subsystem has been redesigned to make it more
     flexible.  The new design takes advantage of the improved
     variable-linking mechanism to allow packages to export bindings
     using names different from their internal names.  Also, each
     package now maintains an in-memory data structure that should (in
     principal) allow it to be uninstalled or reinstalled.  This
     subsystem is still evolving; expect further changes in the future.

     This subsystem is now included in the released binaries; it can be
     loaded by `(load-option 'cref)'.

   * Compiled-code debugging information is now keyed to prevent using
     the wrong debugging info when examining compiled code.  This means
     that in-memory data structures have an identifying key that is
     matched against a corresponding key in the debugging-info file.
     The debugging info is used only when the keys match.

   * MIT Scheme now has a non-validating XML parser that is mostly
     conformant (except that it doesn't support UTF-16).

   * There is very limited support for UTF-8.  At present this is only
     used by the XML parser.

   * All string and character procedures now operate on ISO-8859-1
     rather than US-ASCII as the base character set.  This isn't real
     internationalization support, but at least it broadens the
     character support slightly.  This involved changing a number of
     procedures that were formerly written in C and are now written in
     Scheme, which may have a performance impact on some uses.

   * The procedure `length' now detects circularities in its argument
     and signals an error.

   * A new `rexp' facility provides a more readable syntax for
     specifying regular expressions.  This syntax can be compiled into
     the usual syntax.

   * There is a new "parser buffer" abstraction that supports the
     building of parsers with backtracking.  An associated high-level
     parser description language allows parsers to be described in a
     BNF-like language that is compiled into efficient Scheme code.

   * A new procedure `flo:finite?' returns `#f' for infinite or `NaN'
     flonums and `#t' for all others.

   * The signal-handling code for GNU/Linux systems has been changed to
     take advantage of additional information identifying the types of
     arithmetic exceptions.  This allows more accurate error messages to
     be generated.

   * The following procedure names were changed:

     Old name                           New name
     `list-transform-positive'          `keep-matching-items'
     `list-transform-negative'          `delete-matching-items'
     `list-search-positive'             `find-matching-item'

     and the following new procedures were implemented:
     `keep-matching-items!' and `delete-matching-items!'.

   * IMAIL now supports commands to sort folders according to various
     criteria.  The design is similar to that of Rmail.

   * IMAIL has been re-engineered to improve performance on very large
     folders.  There is now a disk cache for each IMAP folder, to
     eliminate unnecessary network delays.  Also, the summary buffer
     previously used a quadratic algorithm to associate lines in the
     summary with messages in the folder; it now uses a linear
     algorithm.

   * A new IMAIL command `imail-file-message' appends the text of a
     message to a file more or less as it appears in the buffer.  This
     is intended to allow collecting messages into a file in a
     human-readable format.

   * IMAIL used to determine the type of file folders by their file
     names; now it examines the file contents instead.  When creating a
     new file folder, it prompts for the type.

GNU Free Documentation License
******************************

                        Version 1.1, March 2000
     Copyright (C) 2000  Free Software Foundation, Inc.
     59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

     Everyone is permitted to copy and distribute verbatim copies
     of this license document, but changing it is not allowed.

  0. PREAMBLE

     The purpose of this License is to make a manual, textbook, or other
     written document "free" in the sense of freedom: to assure everyone
     the effective freedom to copy and redistribute it, with or without
     modifying it, either commercially or noncommercially.  Secondarily,
     this License preserves for the author and publisher a way to get
     credit for their work, while not being considered responsible for
     modifications made by others.

     This License is a kind of "copyleft", which means that derivative
     works of the document must themselves be free in the same sense.
     It complements the GNU General Public License, which is a copyleft
     license designed for free software.

     We have designed this License in order to use it for manuals for
     free software, because free software needs free documentation: a
     free program should come with manuals providing the same freedoms
     that the software does.  But this License is not limited to
     software manuals; it can be used for any textual work, regardless
     of subject matter or whether it is published as a printed book.
     We recommend this License principally for works whose purpose is
     instruction or reference.

  1. APPLICABILITY AND DEFINITIONS

     This License applies to any manual or other work that contains a
     notice placed by the copyright holder saying it can be distributed
     under the terms of this License.  The "Document", below, refers to
     any such manual or work.  Any member of the public is a licensee,
     and is addressed as "you".

     A "Modified Version" of the Document means any work containing the
     Document or a portion of it, either copied verbatim, or with
     modifications and/or translated into another language.

     A "Secondary Section" is a named appendix or a front-matter
     section of the Document that deals exclusively with the
     relationship of the publishers or authors of the Document to the
     Document's overall subject (or to related matters) and contains
     nothing that could fall directly within that overall subject.
     (For example, if the Document is in part a textbook of
     mathematics, a Secondary Section may not explain any mathematics.)
     The relationship could be a matter of historical connection with
     the subject or with related matters, or of legal, commercial,
     philosophical, ethical or political position regarding them.

     The "Invariant Sections" are certain Secondary Sections whose
     titles are designated, as being those of Invariant Sections, in
     the notice that says that the Document is released under this
     License.

     The "Cover Texts" are certain short passages of text that are
     listed, as Front-Cover Texts or Back-Cover Texts, in the notice
     that says that the Document is released under this License.

     A "Transparent" copy of the Document means a machine-readable copy,
     represented in a format whose specification is available to the
     general public, whose contents can be viewed and edited directly
     and straightforwardly with generic text editors or (for images
     composed of pixels) generic paint programs or (for drawings) some
     widely available drawing editor, and that is suitable for input to
     text formatters or for automatic translation to a variety of
     formats suitable for input to text formatters.  A copy made in an
     otherwise Transparent file format whose markup has been designed
     to thwart or discourage subsequent modification by readers is not
     Transparent.  A copy that is not "Transparent" is called "Opaque".

     Examples of suitable formats for Transparent copies include plain
     ASCII without markup, Texinfo input format, LaTeX input format,
     SGML or XML using a publicly available DTD, and
     standard-conforming simple HTML designed for human modification.
     Opaque formats include PostScript, PDF, proprietary formats that
     can be read and edited only by proprietary word processors, SGML
     or XML for which the DTD and/or processing tools are not generally
     available, and the machine-generated HTML produced by some word
     processors for output purposes only.

     The "Title Page" means, for a printed book, the title page itself,
     plus such following pages as are needed to hold, legibly, the
     material this License requires to appear in the title page.  For
     works in formats which do not have any title page as such, "Title
     Page" means the text near the most prominent appearance of the
     work's title, preceding the beginning of the body of the text.

  2. VERBATIM COPYING

     You may copy and distribute the Document in any medium, either
     commercially or noncommercially, provided that this License, the
     copyright notices, and the license notice saying this License
     applies to the Document are reproduced in all copies, and that you
     add no other conditions whatsoever to those of this License.  You
     may not use technical measures to obstruct or control the reading
     or further copying of the copies you make or distribute.  However,
     you may accept compensation in exchange for copies.  If you
     distribute a large enough number of copies you must also follow
     the conditions in section 3.

     You may also lend copies, under the same conditions stated above,
     and you may publicly display copies.

  3. COPYING IN QUANTITY

     If you publish printed copies of the Document numbering more than
     100, and the Document's license notice requires Cover Texts, you
     must enclose the copies in covers that carry, clearly and legibly,
     all these Cover Texts: Front-Cover Texts on the front cover, and
     Back-Cover Texts on the back cover.  Both covers must also clearly
     and legibly identify you as the publisher of these copies.  The
     front cover must present the full title with all words of the
     title equally prominent and visible.  You may add other material
     on the covers in addition.  Copying with changes limited to the
     covers, as long as they preserve the title of the Document and
     satisfy these conditions, can be treated as verbatim copying in
     other respects.

     If the required texts for either cover are too voluminous to fit
     legibly, you should put the first ones listed (as many as fit
     reasonably) on the actual cover, and continue the rest onto
     adjacent pages.

     If you publish or distribute Opaque copies of the Document
     numbering more than 100, you must either include a
     machine-readable Transparent copy along with each Opaque copy, or
     state in or with each Opaque copy a publicly-accessible
     computer-network location containing a complete Transparent copy
     of the Document, free of added material, which the general
     network-using public has access to download anonymously at no
     charge using public-standard network protocols.  If you use the
     latter option, you must take reasonably prudent steps, when you
     begin distribution of Opaque copies in quantity, to ensure that
     this Transparent copy will remain thus accessible at the stated
     location until at least one year after the last time you
     distribute an Opaque copy (directly or through your agents or
     retailers) of that edition to the public.

     It is requested, but not required, that you contact the authors of
     the Document well before redistributing any large number of
     copies, to give them a chance to provide you with an updated
     version of the Document.

  4. MODIFICATIONS

     You may copy and distribute a Modified Version of the Document
     under the conditions of sections 2 and 3 above, provided that you
     release the Modified Version under precisely this License, with
     the Modified Version filling the role of the Document, thus
     licensing distribution and modification of the Modified Version to
     whoever possesses a copy of it.  In addition, you must do these
     things in the Modified Version:

       A. Use in the Title Page (and on the covers, if any) a title
          distinct from that of the Document, and from those of
          previous versions (which should, if there were any, be listed
          in the History section of the Document).  You may use the
          same title as a previous version if the original publisher of
          that version gives permission.

       B. List on the Title Page, as authors, one or more persons or
          entities responsible for authorship of the modifications in
          the Modified Version, together with at least five of the
          principal authors of the Document (all of its principal
          authors, if it has less than five).

       C. State on the Title page the name of the publisher of the
          Modified Version, as the publisher.

       D. Preserve all the copyright notices of the Document.

       E. Add an appropriate copyright notice for your modifications
          adjacent to the other copyright notices.

       F. Include, immediately after the copyright notices, a license
          notice giving the public permission to use the Modified
          Version under the terms of this License, in the form shown in
          the Addendum below.

       G. Preserve in that license notice the full lists of Invariant
          Sections and required Cover Texts given in the Document's
          license notice.

       H. Include an unaltered copy of this License.

       I. Preserve the section entitled "History", and its title, and
          add to it an item stating at least the title, year, new
          authors, and publisher of the Modified Version as given on
          the Title Page.  If there is no section entitled "History" in
          the Document, create one stating the title, year, authors,
          and publisher of the Document as given on its Title Page,
          then add an item describing the Modified Version as stated in
          the previous sentence.

       J. Preserve the network location, if any, given in the Document
          for public access to a Transparent copy of the Document, and
          likewise the network locations given in the Document for
          previous versions it was based on.  These may be placed in
          the "History" section.  You may omit a network location for a
          work that was published at least four years before the
          Document itself, or if the original publisher of the version
          it refers to gives permission.

       K. In any section entitled "Acknowledgements" or "Dedications",
          preserve the section's title, and preserve in the section all
          the substance and tone of each of the contributor
          acknowledgements and/or dedications given therein.

       L. Preserve all the Invariant Sections of the Document,
          unaltered in their text and in their titles.  Section numbers
          or the equivalent are not considered part of the section
          titles.

       M. Delete any section entitled "Endorsements".  Such a section
          may not be included in the Modified Version.

       N. Do not retitle any existing section as "Endorsements" or to
          conflict in title with any Invariant Section.

     If the Modified Version includes new front-matter sections or
     appendices that qualify as Secondary Sections and contain no
     material copied from the Document, you may at your option
     designate some or all of these sections as invariant.  To do this,
     add their titles to the list of Invariant Sections in the Modified
     Version's license notice.  These titles must be distinct from any
     other section titles.

     You may add a section entitled "Endorsements", provided it contains
     nothing but endorsements of your Modified Version by various
     parties-for example, statements of peer review or that the text has
     been approved by an organization as the authoritative definition
     of a standard.

     You may add a passage of up to five words as a Front-Cover Text,
     and a passage of up to 25 words as a Back-Cover Text, to the end
     of the list of Cover Texts in the Modified Version.  Only one
     passage of Front-Cover Text and one of Back-Cover Text may be
     added by (or through arrangements made by) any one entity.  If the
     Document already includes a cover text for the same cover,
     previously added by you or by arrangement made by the same entity
     you are acting on behalf of, you may not add another; but you may
     replace the old one, on explicit permission from the previous
     publisher that added the old one.

     The author(s) and publisher(s) of the Document do not by this
     License give permission to use their names for publicity for or to
     assert or imply endorsement of any Modified Version.

  5. COMBINING DOCUMENTS

     You may combine the Document with other documents released under
     this License, under the terms defined in section 4 above for
     modified versions, provided that you include in the combination
     all of the Invariant Sections of all of the original documents,
     unmodified, and list them all as Invariant Sections of your
     combined work in its license notice.

     The combined work need only contain one copy of this License, and
     multiple identical Invariant Sections may be replaced with a single
     copy.  If there are multiple Invariant Sections with the same name
     but different contents, make the title of each such section unique
     by adding at the end of it, in parentheses, the name of the
     original author or publisher of that section if known, or else a
     unique number.  Make the same adjustment to the section titles in
     the list of Invariant Sections in the license notice of the
     combined work.

     In the combination, you must combine any sections entitled
     "History" in the various original documents, forming one section
     entitled "History"; likewise combine any sections entitled
     "Acknowledgements", and any sections entitled "Dedications".  You
     must delete all sections entitled "Endorsements."

  6. COLLECTIONS OF DOCUMENTS

     You may make a collection consisting of the Document and other
     documents released under this License, and replace the individual
     copies of this License in the various documents with a single copy
     that is included in the collection, provided that you follow the
     rules of this License for verbatim copying of each of the
     documents in all other respects.

     You may extract a single document from such a collection, and
     distribute it individually under this License, provided you insert
     a copy of this License into the extracted document, and follow
     this License in all other respects regarding verbatim copying of
     that document.

  7. AGGREGATION WITH INDEPENDENT WORKS

     A compilation of the Document or its derivatives with other
     separate and independent documents or works, in or on a volume of
     a storage or distribution medium, does not as a whole count as a
     Modified Version of the Document, provided no compilation
     copyright is claimed for the compilation.  Such a compilation is
     called an "aggregate", and this License does not apply to the
     other self-contained works thus compiled with the Document, on
     account of their being thus compiled, if they are not themselves
     derivative works of the Document.

     If the Cover Text requirement of section 3 is applicable to these
     copies of the Document, then if the Document is less than one
     quarter of the entire aggregate, the Document's Cover Texts may be
     placed on covers that surround only the Document within the
     aggregate.  Otherwise they must appear on covers around the whole
     aggregate.

  8. TRANSLATION

     Translation is considered a kind of modification, so you may
     distribute translations of the Document under the terms of section
     4.  Replacing Invariant Sections with translations requires special
     permission from their copyright holders, but you may include
     translations of some or all Invariant Sections in addition to the
     original versions of these Invariant Sections.  You may include a
     translation of this License provided that you also include the
     original English version of this License.  In case of a
     disagreement between the translation and the original English
     version of this License, the original English version will prevail.

  9. TERMINATION

     You may not copy, modify, sublicense, or distribute the Document
     except as expressly provided for under this License.  Any other
     attempt to copy, modify, sublicense or distribute the Document is
     void, and will automatically terminate your rights under this
     License.  However, parties who have received copies, or rights,
     from you under this License will not have their licenses
     terminated so long as such parties remain in full compliance.

 10. FUTURE REVISIONS OF THIS LICENSE

     The Free Software Foundation may publish new, revised versions of
     the GNU Free Documentation License from time to time.  Such new
     versions will be similar in spirit to the present version, but may
     differ in detail to address new problems or concerns.  See
     `http://www.gnu.org/copyleft/'.

     Each version of the License is given a distinguishing version
     number.  If the Document specifies that a particular numbered
     version of this License "or any later version" applies to it, you
     have the option of following the terms and conditions either of
     that specified version or of any later version that has been
     published (not as a draft) by the Free Software Foundation.  If
     the Document does not specify a version number of this License,
     you may choose any version ever published (not as a draft) by the
     Free Software Foundation.

ADDENDUM: How to use this License for your documents
====================================================

   To use this License in a document you have written, include a copy of
the License in the document and put the following copyright and license
notices just after the title page:

       Copyright (C)  YEAR  YOUR NAME.
       Permission is granted to copy, distribute and/or modify this document
       under the terms of the GNU Free Documentation License, Version 1.1
       or any later version published by the Free Software Foundation;
       with the Invariant Sections being LIST THEIR TITLES, with the
       Front-Cover Texts being LIST, and with the Back-Cover Texts being LIST.
       A copy of the license is included in the section entitled ``GNU
       Free Documentation License''.

   If you have no Invariant Sections, write "with no Invariant Sections"
instead of saying which ones are invariant.  If you have no Front-Cover
Texts, write "no Front-Cover Texts" instead of "Front-Cover Texts being
LIST"; likewise for Back-Cover Texts.

   If your document contains nontrivial examples of program code, we
recommend releasing these examples in parallel under your choice of
free software license, such as the GNU General Public License, to
permit their use in free software.